#ifndef	ADE7758_H
#define	ADE7758_H

#define PARAMETER 17 //ܼĴеֵתʵʵֵļƲ   
   
#define uchar unsigned char   
#define uint  unsigned int   
#define ulong unsigned long   
//key value table   
#define KeyUp       0xfd   
#define KeyDown     0xfb   
#define KeyEnter    0xf7   
#define KeyCancel   0xef   
//eerom address define   
#define EEROM_TAE 10        //5bytes  first:flag,second to five:data   
#define EEROM_TVAE 16       // 5bytes  first:flag,second to five:data   
#define EEROM_DATE 22       //ſʼƵ ʱַ6ֽ   
//eerom address of saveing parameter   
#define EEROM_FLA  29   
#define EEROM_PAR  30       //Ųʼַ,ڼֽڴһ12BIT   
#define EEROM_CRC  90               //ŲУ   
//save ok define   
#define SAVE_OK 0XAA            //ĸֽڵЧ־   
   
   
   
//register  name     address    length   
   
//read only register   
#define AWATTHR   0X01      //16  Phase A Watt-Hour accumulation   
#define BWATTHR   0X02      //16  Phase B Watt-Hour accumulation   
#define CWATTHR   0X03      //16  Phase C Watt-Hour accumulation   
   
#define AVARHR    0X04      //16  Var-Hour accumulation register for phase A   
#define BVARHR    0X05      //16  Var-Hour accumulation register for phase b   
#define CVARHR    0X06      //16  Var-Hour accumulation register for phase c   
   
#define AVAHR     0X07      //16   
#define BVAHR     0X08      //16   
#define CVAHR     0X09      //16   
   
   
#define AIRMS     0X0A      //24  Current register   
#define BIRMS     0X0B      //24   
#define CIRMS     0X0C      //24   
   
#define AVRMS     0X0D      //24  Voltage register   
#define BVRMS     0X0E      //24   
#define CVRMS     0X0F      //24   
//end of read only register   
#define COMPMODE  0x16      //8   R/W DEFAULT VALUE 0x1C   
   
#define MASK      0X18      //24    R/W IRQ Mask register,determines if an interrup event will generate an active-low output at IRQ pin   
   
#define RSTATUS   0X1A      //24  READ ONLY,CLEANED ZERO after a read operation   
   
   
#define GAIN      0X23      //8     R/W 0~1bit used to select the Gain of the current channels inputs   
   
#define WDIV      0X42      //8   R/W Active Energy register divider   
#define VARDIV    0X43      //8   R/W Apparent Energy register divider   
#define VADIV     0X44      //8   R/W Apparent Energy register divider   
   
#define FREQ      0X10      //12  Read only,frequency of the line input estimated by zero-crossing processing   
   
   
#define LCYCMODE  0X17      //8   R/W bit7   
#define MMODE     0X14      //8   R/W bit01   
///////////////////////////////////////////////////////////////////////////////////////////   
#define BaseAdd       41   
     
//ӿź   
extern void init_7758();
extern void get_data_from7758(); 
extern unsigned long read7753a(unsigned char type,unsigned char databit);   

#endif