/*********************************************/
//ADC0TEST
//AIN0.2 - ADC0 input
//2016.02.27
//By CQD
/****************ͷļ*******************/
#include<C8051F350.h>
#include<stdio.h>
#include<math.h>
#include<intrins.h>
#include<ADE7758.h>
#define uint  unsigned int
#define uchar unsigned char
#define uint32 unsigned long
/**************16-bit Ĵ**************/
sfr16 ADC0DEC=0X9A;
sfr16 TMR2RL = 0XCA;
sfr16 TMR2 = 0XCC;

/************ʾõĶ˿ڶ************/
sbit lcd_data = P0^4;              //      
sbit lcd_wr   = P1^1;              //д     
sbit lcd_cs   = P1^2;              //Ƭѡ
//ӿź   
sbit CSADE7753_A = P1^4;//ADE7758Ƭѡź   
sbit SSDO        = P1^5;   
sbit SSCK        = P1^6;   
sbit SSDI        = P1^7; 

sbit K1 = P0^5; //
sbit K2 = P0^6; //ȷ   
sbit K3 = P1^0; // 
sbit K4 = P0^7; //˳
/******************궨********************/
#define SYSCLK 24500000  //ϵͳƵHz
#define MDCLK  2457600
#define OWR  20
#define BAUDRATE 9600 //ʲ9600


/***************ʾ궨****************************/
#define  BIAS     0x52             //0b1000 0101 0010  1/3duty 4com 
#define  SYSDIS   0X00             //0b1000 0000 0000  ϵͳLCDƫѹ 
#define  SYSEN    0X02             //0b1000 0000 0010 ϵͳ 
#define  LCDOFF   0X04             //0b1000 0000 0100  LCDƫѹ 
#define  LCDON    0X06             //0b1000 0000 0110  LCDƫѹ 
#define  XTAL     0x28             //0b1000 0010 1000 ⲿʱ 
#define  RC256    0X30             //0b1000 0011 0000  ڲʱ 
#define  TONEON   0X12             //0b1000 0001 0010   
#define  TONEOFF  0X10             //0b1000 0001 0000 ر 
#define  WDTDIS1  0X0A            //0b1000 0000 1010  ֹŹ 

/*****************ʾӦ߼*************************/
//IC    C0  C1  C2  C3  S0  S1  S2  S3  S4  S5  S6  S7  S8  S9  S10  S11  S12
//PIN   1   2   3   4   5   6   7   8   9   10  11  12  13  14  15   16   17
//COM1            COM1  S1  S4  1F  1A  2F  2A  3F  3A  4F  4A  5F   5A   S11
//COM2        COM2      S5  S3  1G  1B  2G  2B  3G  3B  4G  4B  5G   5B   S10
//COM3     COM3         S6  S2  1E  1C  2E  2C  3E  3C  4E  4C  5E   5C   S9
//COM4  COM4            S7      1D  P1  2D  P2  3D  P3  4D  P4  5D        S8

/***************11ģʾ**************/
uchar code Ht1621_gn[]={0x01,0x02,0x04,0x08};
//Ht1621WrOneData(i,t)
//   t  0x01     0x02     0x04     0x08 
// i    
// 0    COS      R        S        P(W)
// 1    NEXT     DISPLAY  SAVE
// 3                               P1
// 5                               P2
// 7                               P3
// 9                               P4
// 12   I(A)     U(V)     S(VA)    Q(Var)



/***************ѡʾ0~9************/
uchar code Ht1621_sz1[]={0X0D,0X00,0X0E,0X0A,0X03,0X0B,0X0F,0X00,0X0F,0X0B};
uchar code Ht1621_sz2[]={0X07,0X06,0X03,0X07,0X06,0X05,0X05,0X07,0X07,0X07};
//////////////////////// 0    1    2    3    4    5    6    7    8     9
extern	uint	Cur_div[3];
extern	uint	Cur_buf[3]; 
uchar key_fg;
/***************************************/
void Oscillator_Init(void);
void Port_Init(void);
void TIMER2_Init (void);
//-----------------------------------------------------------------------------------------
//ƣDelay()
//    ܣʱӳ
//-----------------------------------------------------------------------------------------
void Delay_us (uchar time_us)
{
   TR2   = 0;                          // Stop timer
   TF2H  = 0;                          // Clear timer overflow flag
   TMR2  = -( (uint)(SYSCLK/1000000) * (uint)(time_us) );
   TR2   = 1;                          // Start timer
   while (!TF2H);                      // Wait till timer overflow occurs
   TR2   = 0;                          // Stop timer
}
//-----------------------------------------------------------------------------------------
//ƣDelayMS()
//    ܣʱӳ
//-----------------------------------------------------------------------------------------
void DelayMS (uchar time_ms)
{
   uchar i;

   while(time_ms--)
      for(i = 0; i< 10; i++)           // 10 * 100 microsecond delay
         Delay_us (100);
} 
//-----------------------------------------------------------------------------------------
//ƣHt1621Wr_Data() 
//    ܣдݺ,cntΪλ,ݴΪλǰ 
//-----------------------------------------------------------------------------------------
void Ht1621Wr_Data(uchar Data,uchar cnt) 
{ 
 uchar i; 
   for (i=0;i<cnt;i++) 
   {   
   lcd_wr=0; 
  //NOP();
  //NOP();
  //NOP();
  //NOP();

  if((Data & 0x80)==0x80)
  {
  lcd_data = 1;
  }
  else
  {
  lcd_data = 0;
  }
  lcd_wr = 1; 
  //NOP();
  //NOP();
  //NOP();
  //NOP();
      Data<<=1;  
   } 
} 
//-----------------------------------------------------------------------------------------
//ƣvoid Ht1621WrCmd(uchar Cmd) 
//: HT1621д뺯 
//˵CmdΪд  
//˵    дʶλ100 
//-----------------------------------------------------------------------------------------
void Ht1621WrCmd(uchar Cmd) 
{ 
 lcd_cs= 0; 
 //NOP();
 //NOP();
 //NOP();
 //NOP();
   Ht1621Wr_Data(0x80,4);          //д־100 
   Ht1621Wr_Data(Cmd,8);                 //д 
   lcd_cs = 1; 
} 
//-----------------------------------------------------------------------------------------
//ƣvoid Ht1621WrOneData(uchar Addr,uchar Data) 
//: HT1621ַָдݺ 
//˵AddrΪдʼַDataΪд  
//˵    ΪHT1621λ4λʵдΪĺ4λ 
//-----------------------------------------------------------------------------------------
void Ht1621WrOneData(uchar Addr,uchar Data) 
{ 
  lcd_cs = 0; 
  Ht1621Wr_Data(0xa0,3);                 //дݱ־101 
  Ht1621Wr_Data(Addr<<2,6);          //дַ 
  Ht1621Wr_Data(Data<<4,4);          //д 
  lcd_cs = 1;   
} 
//-----------------------------------------------------------------------------------------
//ƣvoid Ht1621WrAllData() 
//: HT1621д뷽ʽ 
//˵    HT1621λ4λ˴ÿΪ8λд8λ 
//-----------------------------------------------------------------------------------------
void Ht1621WrAllData(void) 
{ 
 uchar i; 

 lcd_cs = 0;; 

  Ht1621Wr_Data(0xa0,3);          //дݱ־101 
   Ht1621Wr_Data(0x00<<2,6);         //дַ 

   for (i=0;i<16;i++) 
   { 
          Ht1621Wr_Data(0x00,8);         //д 
   } 
   lcd_cs = 1;   
}

//-----------------------------------------------------------------------------------------
//ƣvoid shuzi(uchar a , uchar b) 
//ʾ
//˵    a:ʾҪʾa     b:ʾҪʾΪb
//-----------------------------------------------------------------------------------------
void shuzi(uchar a , uchar b)
{
	Ht1621WrOneData(2*a,Ht1621_sz1[b]);
  Ht1621WrOneData(2*a+1,Ht1621_sz2[b]);

}
//-----------------------------------------------------------------------------------------
//????:void szxs(uchar a , uchar b) 
//????:???????????
//?    ?:a:????????a     b:?????????b
//-----------------------------------------------------------------------------------------
void szxs(uchar a , uchar b)
{
	Ht1621WrOneData(2*a,Ht1621_sz1[b]);
  Ht1621WrOneData(2*a+1,Ht1621_sz2[b]+0x08);
}

//-----------------------------------------------------------------------------------------
//ƣvoid Ht1621_Init(void) 
//: HT1621ʼ 
//˵    ʼҺֶξʾ 
//-----------------------------------------------------------------------------------------
void Ht1621_Init(void) 
{ 
  // HT1621_CS=1; 
  // HT1621_WR=1; 
  // HT1621_DAT=1; 
   DelayMS(20);                     //ʱʹLCDѹȶ 
   Ht1621WrCmd(BIAS); 
   Ht1621WrCmd(RC256);              //ʹڲ
   Ht1621WrCmd(WDTDIS1); 
   Ht1621WrCmd(SYSEN); 
   Ht1621WrCmd(LCDON); 
}

void RUN()
{
	Ht1621WrOneData(0,0x02);
	DelayMS(2000);
	Ht1621WrOneData(0,0x00);
}

void STOP()
{
	Ht1621WrOneData(0,0x04);
}


/******************************************************************************************  
                         7758д  
******************************************************************************************/   
void write7753(unsigned char type, long wdata,unsigned char databit)   
{   
    unsigned char loop = 0;   
    unsigned char flag;
		flag = databit;
    type = type & 0x7F;   
    type = type | 0x80;   
    for(loop = 0; loop < 8; loop++)   
    {   
        SSCK = 1;   
        _nop_();   
        SSDI = type & 0X80;   
        _nop_();   
        SSCK = 0;   
        _nop_();   
        type = (type << 1);   
    }//end of for()   
       
    Delay_us(10);   
       
    for(loop = 0; loop < databit; loop++)   
    {   
        SSCK = 1;   
        _nop_();
				if(flag==8)
			  SSDI = wdata & 0X80;
				if(flag==12)
			  SSDI = wdata & 0X800;
				if(flag==16)
			  SSDI = wdata & 0X8000;
				if(flag==24)
        SSDI = wdata & 0X800000;   
        _nop_();   
        SSCK = 0;   
        _nop_();   
        wdata = (wdata << 1);   
    }//end of for()   
       
}//end of write7753()   
   
/*******************************************************************************************  
********************************************************************************************/   
unsigned long read7753(unsigned char type,unsigned char databit)   
{   
    unsigned char loop = 0;   
    unsigned long  rtdata = 0;   
    //ade7758 7 bits address   
    //ade7754 6 bits address   
    type = type & 0x7F;   
    type = type | 0x00;   
    for(loop = 0;loop < 8;loop ++)   
    {   
        SSCK = 1;   
    _nop_();   
    SSDI = type & 0X80;   
    _nop_();   
        SSCK = 0;   
    _nop_();   
    type = (type << 1);   
    }   
    Delay_us(10);   
    for(loop = 0;loop < databit;loop ++)   
    {   
        SSCK = 1;   
    _nop_();   
    rtdata = (rtdata << 1);   
    if(SSDO) rtdata += 1;   
    _nop_();   
    SSCK = 0;   
    _nop_();   
    }   
    return(rtdata);   
}//end of read7753()   
   
/*****************************************************************   
******************************************************************/   
void write7753a(unsigned char type, int wdata,unsigned char databit)   
{   
    //EA = 0;//disable interrupt   
    CSADE7753_A = 1;           
    SSCK = 0;   
    SSDI = 0;   
    SSDO = 0;   
    CSADE7753_A = 0;   
    write7753(type,wdata,databit);   
    CSADE7753_A = 1;   
    //EA = 1;//enable interrupt   
}     
/*******************************************************************************************  
                          7758 
********************************************************************************************/   
unsigned long read7753a(unsigned char type,unsigned char databit)   
{   
    unsigned long  rtdata = 0;   
    //EA = 0;//disable interrupt   
    CSADE7753_A = 1;            
    SSCK = 0;   
    SSDI = 0;   
    SSDO = 0;   
    CSADE7753_A = 0;   
    rtdata = read7753(type,databit);   
    CSADE7753_A = 1;   
    //EA = 1;//enable interrupt   
    return(rtdata);   
}//end of read7753a()      
/****************************************************************  
*****************************************************************/   
   
void get_data_from7758()   
{   
	uint32	Cur_data[3];
	Cur_data[0] = read7753a(AIRMS,24);    
//Cur_data[1] = read7753a(BIRMS,24);
//Cur_data[2] = read7753a(CIRMS,24);  
}  
/**********************************************************************************************  
                     7758ʼ    
***********************************************************************************************/   
void init_7758()   
{      
    write7753a(0x13,0x40,8);      //ģʽ 
    Delay_us(200); 								//һʱ
		write7753a(0x13,0x00,8);      //ģʽ 
		write7753a(0x1c,0x000A,16);		//ѭĴ
		write7753a(0x1d,100,8);	
		write7753a(0x16,0xA4,8);    	//ѭģʽĴ 
		write7753a(0x17,0x0f,8);    	//ѭģʽĴ 
		write7753a(0x18,0x0200,24);   //жμĴ 
		write7753a(0x15,0x24,8);			//ģʽĴ
    write7753a(0x23,0x00,8);     	//PGAĴ   
    write7753a(0x24,0x00,16);   	//λAVRMSĴ 
    write7753a(0x25,0x00,16);   	//λBVRMSĴ
    write7753a(0x26,0x00,16);   	//λCVRMSĴ 
    write7753a(0x27,0x00,16);     //λAĵĴ 
    write7753a(0x28,0x00,16);     //λBĵĴ  
    write7753a(0x29,0x00,16);     //λCĵĴ  

    write7753a(0x33,0x00,12);     //λAVRMSУĴ  
    write7753a(0x34,0x00,12);     //λBVRMSУĴ  
    write7753a(0x35,0x00,12);     //λCVRMSУĴ 

    write7753a(0x36,0x00,12);     //λAIRMSУĴ 
    write7753a(0x37,0x00,12);     //λAIRMSУĴ
    write7753a(0x38,0x00,12);     //λAIRMSУĴ
		
		write7753a(0x39,0x00,12);     //λAIRMSУĴ 
    write7753a(0x3A,0x00,12);     //λAIRMSУĴ
    write7753a(0x3B,0x00,12);     //λAIRMSУĴ
		
    write7753a(0x3f,0x00,8);     	//λAIRMSУĴ 
    write7753a(0x40,0x00,8);     	//λAIRMSУĴ 
    write7753a(0x41,0x00,8);     	//λAIRMSУĴ 
		
//		write7753a(0x42,0x32,8);     	//λAIRMSУĴ 
//   write7753a(0x43,0x32,8);     	//λAIRMSУĴ 
//    write7753a(0x44,0x32,8);     	//λAIRMSУĴ 

} 
void KEY()
{
	if (K1 == 0)                  
      { 
				DelayMS(20);
				if (K1 == 0)               
				{
					while(K1==0);
					key_fg++; 
						if(key_fg>5)
							key_fg=0;
				}   
      }
	switch(key_fg)
	{
		case 0:Ht1621WrOneData(12,0x01);Ht1621WrOneData(0,0x00);break;
		case 1:Ht1621WrOneData(12,0x02);break;
		case 2:Ht1621WrOneData(12,0x04);break;
		case 3:Ht1621WrOneData(12,0x08);break;
		case 4:Ht1621WrOneData(12,0x00);Ht1621WrOneData(0,0x08);break;
		case 5:Ht1621WrOneData(0,0x01);break;
	}
}

//-----------------------------------------------------------------------------------------
//ƣvoid main(void)
//:
//-----------------------------------------------------------------------------------------
void main(void)
{
	unsigned char i,j,m,n,a,b;
	unsigned long A,V,VA,VAR,WATT,PF,SPF=0,SVA=0,SA=0,SVAR=0,SWATT=0,SV=0;
	PCA0MD &=~0X40;      					//رտŹ
	Oscillator_Init();   					//ʼ
	Port_Init();         					//˿ڳʼ
	TIMER2_Init ();
	init_7758();
	Ht1621_Init();        					//ϵʼLCD 
	DelayMS(10);          					//ʱһʱ 
	Ht1621WrAllData();    					//ʼеĶζеĶιر
	Ht1621WrOneData(0,0x04);				//ʾS R
	//Ht1621WrOneData(12,0x01);    	//ʾI U P S COS
	Ht1621WrOneData(1,0x02);				//ʾ NEXT DISPLAY SET 
	EA=1;                						//ʹͨж
	while(1)
	{	
	VAR = read7753a(AVARHR,16);	
	KEY(); 
	if(key_fg==1)
		{
			i++;
			V = read7753a(AVRMS,24)*60*100/28700;
			SV=SV+V;
			if(i>=100)
			{
				i=0;
				SV=SV/100;
				shuzi(1,(uchar)(SV/100000));	
				shuzi(2,(uchar)(SV/10000%10));
				szxs(3,(uchar)(SV/1000%10));
				shuzi(4,(uchar)(SV/100%10));
				shuzi(5,(uchar)(SV/10%10));
				DelayMS(100);
				SV=0;
			}
			
		}
	if(key_fg==0)
	{
		j++;
		A = read7753a(AIRMS,24)*100*102/71800;
		SA=SA+A;
		if(j>=100)
		{
			j=0;
			SA=SA/100;
			szxs(1,(uchar)(SA/100000));	
			shuzi(2,(uchar)(SA/10000%10));
			shuzi(3,(uchar)(SA/1000%10));
			shuzi(4,(uchar)(SA/100%10));
			shuzi(5,(uchar)(SA/10%10));
			DelayMS(100);
			SA=0;
			}
		}
		if(key_fg==2)
		{
		m++;
		VA = read7753a(AVAHR,16)*10*19/16;
		SVA=SVA+VA;
		if(m>=100)
		{
			m=0;
			SVA=SVA/100;
			shuzi(1,(uchar)(SVA/100000));	
			shuzi(2,(uchar)(SVA/10000%10));
			shuzi(3,(uchar)(SVA/1000%10));
			szxs(4,(uchar)(SVA/100%10));
			shuzi(5,(uchar)(SVA/10%10));
			DelayMS(100);
			SVA=0;
		}
		}
		
		if(key_fg==3)
		{
		n++;
		VAR = read7753a(AVARHR,16)/100;
		SVAR=SVAR+VAR;
		if(n>=100)
		{
			n=0;
			SVAR=SVAR/100;
			shuzi(1,(uchar)(SVAR/100000));	
			shuzi(2,(uchar)(SVAR/10000%10));
			shuzi(3,(uchar)(SVAR/1000%10));
			szxs(4,(uchar)(SVAR/100%10));
			shuzi(5,(uchar)(SVAR/10%10));
			DelayMS(100);
			SVAR=0;
		}
		}
		
		if(key_fg==4)
		{
		a++;
		WATT = read7753a(AWATTHR,16)/100;
		SWATT=SWATT+WATT;
		if(n>=100)
		{
			n=0;
			SWATT=SWATT/100;
			shuzi(1,(uchar)(SWATT/100000));	
			shuzi(2,(uchar)(SWATT/10000%10));
			shuzi(3,(uchar)(SWATT/1000%10));
			szxs(4,(uchar)(SWATT/100%10));
			shuzi(5,(uchar)(SWATT/10%10));
			DelayMS(100);
			SWATT=0;
		}
		}
		
		if(key_fg==5)
		{
		b++;
		PF = read7753a(AWATTHR,16)/read7753a(AVAHR,16);
		SPF=SPF+PF;
		if(n>=100)
		{
			n=0;
			SPF=SPF/100;
			shuzi(1,(uchar)(SPF/100000));	
			shuzi(2,(uchar)(SPF/10000%10));
			shuzi(3,(uchar)(SPF/1000%10));
			szxs(4,(uchar)(SPF/100%10));
			shuzi(5,(uchar)(SPF/10%10));
			DelayMS(100);
			SPF=0;
		}
		}
	}
}

//ʼ
void Oscillator_Init(void)
{
	OSCICN = 0X83;
	RSTSRC =0X04;
}

//˿ڳʼ
void Port_Init(void)
{
	XBR0 = 0X40;
	XBR1 = 0X40;
  P1MDIN |= 0XF7;          //P1.2 1.3 1.4 Ϊֶ˿
	P0MDIN |= 0XF0;
	P1MDOUT = 0XD6;          //P1.2 1.3 1.4 
	P0MDOUT = 0X10;
}

void TIMER2_Init (void) 
{
   CKCON    |= 0x10;
}




